﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private fx As JFX
	Private clrfunctions As colorfunctions
	Private pncanvas As Pane
	Private pnscroll As Pane
	Private spane As ScrollPane
	Public gridsize As Int = 10
	Private B4XSeekBar1 As B4XSeekBar
	Private B4XSeekBar2 As B4XSeekBar
	Private tbtngrid As ToggleButton
	Public cardsfolder As String
	Public filesfolder As String
	Public layoutsfolder As String
	Public shapesfolder As String
	Public lblmessage As Label
	Private panemain As Pane
	Public pressedX As Double
	Public pressedY As Double
	Public currnode As B4XView
	Private btnreset As Button
	Private ZoomImageView1 As ZoomImageView
	Public zoomviewwidth As Double
	Public zoomviewheight As Double
	Public cboxfilled As CheckBox
	Public cbxheight As B4XComboBox
	Public cbxstrokewidth As B4XComboBox
	Public cbxwidth As B4XComboBox
	Public sizelst As List
	Public strokewidthlst As List
	Public cornerradiuslst As List
	Public lbldeleteshape As Label
	Public lbldeleteicon As Label
	Public lblchangeshape As Label
	Public lblsaveshape As Label
	Public lblchangeicon As Label
	Public lblsaveicon As Label
	Public pnsettings As Pane
	Private clvnamedcolors As CustomListView
	Public jlst As List
	Private RGB As List
	Private lblcolor As Label
	Private lblcolorname As Label
	Private tbtnshapshot As ToggleButton
	Public lbldeletetext As Label
	Public lblnewtext As Label
	Public clvfonts As CustomListView
	Public pntext As Pane
	Public tatext As TextArea
	Public pntextscnt As Int = 0
	Public loadedpane As Pane
	Public fchoose As FileChooser
	Public tbtntextpane As ToggleButton
	Private cboxnoborder As CheckBox
	Private cbxalignment As B4XComboBox
	Private lblfontitem As Label
	Private fontfamilylst As List
	Public selectedfont As String
	Private cbxfontsize As B4XComboBox
	Private fontsizelst As List = Array As Int(10,12,14,16,18,20,22,24,26,28,30,32,34,36,38,40,42,44,46,48,50)
	Public selectedfontsize As Int
	Private ProgressBar1 As ProgressBar
	Private cbxtextcolors As B4XComboBox
	Public selectednamedcolor As Int
	Public selectedtextcolor As String
	Public tbtncomponents As ToggleButton
	Private lblselectedcomponent As Label
	Private pnproperties As Pane
	Public tbtnpropertiespane As ToggleButton
	Private lblitem As Label
	Private ivitem As ImageView
	Private lblname As Label
	Public colorsmap As Map
	Private cbxcornerradius As B4XComboBox
	Private tbtnshapes As ToggleButton
	Private pnshapes As Pane
	Private clvshapes As CustomListView
	Public collectionmap As Map
	Private nodecnt As Int
	Public alignlst As List
	Public fontindexmap As Map
	Public namedcolorindexmap As Map
	Public carddragged As Boolean = True
	Private tbtnbold As ToggleButton
	Private tbtnitalic As ToggleButton
	Public ctrlkeypressed As Boolean
	Public parentnode As B4XView
	Private btnsavesnapshot As Button
	Private tbtnkeys As ToggleButton
	Private pnkeys As Pane
	Private clvkeys As CustomListView
	Public keylst As List
	Public pnlresizing As Boolean = False
	Public lblresizing As Boolean = False
	Public oldx As Double
	Public oldy As Double
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Storyboard cards_30")
	xui.SetDataFolder("storyboard_cards_30")
	File.MakeDir(xui.DefaultFolder,"cards")
	cardsfolder = File.DirData("storyboard_cards_30") & "\cards"
	File.MakeDir(xui.DefaultFolder,"files")
	filesfolder = File.DirData("storyboard_cards_30") & "\files"
	File.MakeDir(xui.DefaultFolder,"layouts")
	layoutsfolder = File.DirData("storyboard_cards_30") & "\layouts"
	File.MakeDir(xui.DefaultFolder,"shapes")
	shapesfolder = File.DirData("storyboard_cards_30") & "\shapes"
	fontfamilylst = fx.GetAllFontFamilies
	set_progress
	Sleep(0)
	collectionmap.Initialize
	clrfunctions.Initialize
	colorsmap.Initialize
	alignlst.Initialize
	fontindexmap.Initialize
	namedcolorindexmap.Initialize
	Dim jstr As String = File.ReadString(File.DirAssets,"colornames.json")
	jlst = jstr.As(JSON).ToList
	set_progress
	Sleep(0)
	pnkeys.LoadLayout("pnkeys_layout")
	fill_clvkeys
	pnproperties.LoadLayout("pnproperties_layout")
	pnshapes.LoadLayout("pnshapes_layout")
	pnproperties.As(B4XView).SendToBack
'	pnshapes.As(B4XView).SendToBack
	fill_clvshapes
	set_progress
	Sleep(0)
	fchoose.Initialize
	loadedpane.Initialize("")
	spane.PrefWidth = 1270
	spane.PrefHeight = 600
	spane.InnerNode = pncanvas
	spane.InnerNode.PrefHeight = pncanvas.prefHeight
	pnscroll.As(B4XView).SendToBack
	sizelst.Initialize
	strokewidthlst.Initialize
	cornerradiuslst.Initialize
	draw_grid
	zoomviewwidth = ZoomImageView1.ImageView.Height
	zoomviewheight = ZoomImageView1.ImageView.Height
	lblmessage.Text = " Click on a card shape (green border) to start."
	ProgressBar1.Visible = False
	If sizelst.Size = 0 Then fill_properties_pane
End Sub
#Region 01 user interface
Private Sub set_progress
	ProgressBar1.Progress = ProgressBar1.Progress + 0.3
End Sub
Private Sub draw_grid
	Dim scrollcanvas As B4XCanvas
	scrollcanvas.Initialize(pnscroll)
	' horizontal lines
	For ypos = 0 To pnscroll.prefHeight Step gridsize
		If ypos Mod 100 = 0 Then
			scrollcanvas.DrawLine(0,ypos,pnscroll.prefWidth,ypos,xui.Color_Black,2)
		Else
			scrollcanvas.DrawLine(0,ypos,pnscroll.prefWidth,ypos,xui.Color_Gray,0.5)
		End If
	Next
	' vertical lines
	For xpos = 0 To pnscroll.prefWidth Step gridsize
		If xpos Mod 100 = 0 Then
			scrollcanvas.DrawLine(xpos,0,xpos,pnscroll.PrefHeight,xui.Color_Black,2)
		Else
			scrollcanvas.DrawLine(xpos,0,xpos,pnscroll.PrefHeight,xui.Color_Gray,0.5)
		End If
	Next
	scrollcanvas.Invalidate
End Sub
Private Sub B4XSeekBar1_ValueChanged (Value As Int)
	spane.HPosition = Value/100
End Sub
Private Sub B4XSeekBar2_ValueChanged (Value As Int)
	spane.VPosition = Value/100
End Sub
Private Sub tbtngrid_SelectedChange(Selected As Boolean)
	If Selected Then
		pnscroll.Visible = True
	Else
		pnscroll.Visible = False
	End If
End Sub
Public Sub snap_to_grid(vw As B4XView)
	If vw <> currnode Then Return
	If currnode.IsInitialized Then
		Dim xoff As Int = currnode.Left Mod gridsize
		If xoff <= 10 Then
			currnode.Left = currnode.Left - xoff
		Else
			currnode.Left = currnode.Left - xoff
		End If
		Dim yoff As Int = currnode.Top Mod gridsize
		If yoff <= 10 Then
			currnode.top = currnode.top - yoff
		Else
			currnode.top = currnode.top - yoff
		End If
	End If
End Sub
private Sub make_snapshot
	Dim snap As B4XBitmap = pncanvas.Snapshot
	ZoomImageView1.SetBitmap(snap)
	ZoomImageView1.mBase.Visible = True
	btnsavesnapshot.Visible = True
End Sub
Private Sub tbtnshapshot_SelectedChange(Selected As Boolean)
	If Selected Then
		make_snapshot
		ZoomImageView1.mBase.Visible = True
		btnsavesnapshot.Visible = True
	Else
		ZoomImageView1.mBase.Visible = False
		btnsavesnapshot.Visible = False
	End If
End Sub
Private Sub btnreset_Click
	reset_panemain
End Sub
Public Sub reset_panemain
	Dim answer As Object = xui.Msgbox2Async("All cards and shapes will be deleted!" & CRLF & " Continue?", "Reset panel", "Yes", "Cancel", "No", Null)
	Wait For (answer) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		panemain.RemoveAllNodes
		currnode = Null
		lblmessage.Text = ""
		collectionmap.Initialize
		If tatext.IsInitialized Then tatext.Text = ""
	End If
End Sub
Private Sub btnsavesnapshot_Click
	Dim snap As B4XBitmap = pncanvas.Snapshot
	fchoose.InitialDirectory = filesfolder
	fchoose.InitialFileName = DateTime.Now & "_snapshot" & ".png"
	fchoose.setExtensionFilter("Snapshots", Array As String("*.png"))
	Dim fname As String = fchoose.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
	If fname = "" Then Return
	Dim path As String = fname.SubString2(0,fname.LastIndexOf("\")+1)
	Dim filename As String = fname.SubString(fname.LastIndexOf("\")+1)
	Dim Out As OutputStream
	Out = File.OpenOutput(path, filename, False)
	snap.WriteToStream(Out, 100, "PNG")
	Out.Close
End Sub
Private Sub tbtnkeys_SelectedChange(Selected As Boolean)
	If Selected Then
		pnkeys.As(B4XView).BringToFront
	Else
		pnkeys.As(B4XView).SendToBack
	End If
	
End Sub
Private Sub panemain_MouseDragged (EventData As MouseEvent)
'	If lblresizing = True Then
'		resize_shape(EventData.X,EventData.Y)
'	End If
'	EventData.Consume
End Sub
#End Region
#Region 02 shapes panel
Private Sub tbtnshapes_SelectedChange(Selected As Boolean)
	If Selected Then
		pnshapes.As(B4XView).BringToFront
	Else
		pnshapes.As(B4XView).SendToBack
	End If	
End Sub
Public Sub fill_clvshapes
	Dim lst As List				' all images from the folders
	lst.Initialize
	Dim lst1 As List = File.ListFiles(layoutsfolder)
	For i = 0 To lst1.Size -1
		Dim name As String = lst1.Get(i)
		Dim filename As String = layoutsfolder & "\" & name
		lst.Add(filename)
	Next
	Dim lst2 As List = File.ListFiles(shapesfolder)
	For i = 0 To lst2.Size -1
		Dim name As String = lst2.Get(i)
		Dim filename As String = shapesfolder & "\" & name
		lst.Add(filename)
	Next
	clvshapes.Clear
	Dim rowcnt As Int = 1
	For i = 0 To lst.Size -1 Step 6
		Dim pn As Pane = set_clvshapes_row(lst, rowcnt)
		clvshapes.Add(pn,i)
		rowcnt = rowcnt + 1
	Next
End Sub
Private Sub set_clvshapes_row(flst As List, rcnt As Int) As Pane
	Dim pnrow As Pane
	pnrow.Initialize("")
	pnrow.SetLayoutAnimated(0,5,0,600,130)
	Dim startitem As Int = (rcnt-1)*6
	For x = 0 To 5
		If (startitem+x) < flst.Size Then
			Dim filename As String = flst.Get(startitem+x)
			Dim pn As Pane = set_clvshapes_item(filename)
			pnrow.AddNode(pn,(x*100),0,100,130)
		End If
	Next
	Return pnrow
End Sub
Private Sub set_clvshapes_item(fname As String) As Pane
	Dim path As String = fname.SubString2(0,fname.LastIndexOf("\")+1)
	Dim filename As String = fname.SubString(fname.LastIndexOf("\")+1)
	Dim name As String = filename.SubString2(0,filename.IndexOf("."))
	Dim pn As Pane
	pn.Initialize("")
	pn.LoadLayout("clvshapesitem_layout")
	pn.SetLayoutAnimated(0, 0, 0, 100, 130)
	lblname.Text = " " & name
	lblitem.Tag = fname
	If name.Contains("card") Then CSSUtils.SetBorder(lblitem,3,fx.Colors.Green,3)
	Dim bmp As Image
	bmp.Initialize(path,filename)
	ivitem.SetImage(bmp)
	Return pn
End Sub
Private Sub lblitem_MouseClicked (EventData As MouseEvent)
	Dim view As B4XView = Sender
	Dim tag As String = view.Tag
	Dim folder As String = tag.SubString2(0,tag.LastIndexOf("\"))
	Dim shapetype As String
	If folder.EndsWith("shapes") Then shapetype = "shape"
	If folder.EndsWith("layouts") Then shapetype = "card"
	If shapetype = "card" Then
		add_card(tag)
	Else
		add_shape(tag)
	End If
	EventData.Consume
End Sub
#End Region
#Region 03 properties panel
Private Sub tbtnpropertiespane_SelectedChange(Selected As Boolean)
	If Selected Then
		pnproperties.As(B4XView).BringToFront
	Else
		pnproperties.As(B4XView).SendToBack
	End If
End Sub
private Sub fill_properties_pane
	If sizelst.Size = 0 Then		' only the first time
		ProgressBar1.Progress = 0
		ProgressBar1.Visible = True
		fill_clvnamedcolors
		set_progress
		Sleep(0)
		fill_clvfonts
		set_progress
		Sleep(0)
		For i = 10 To 2000 Step 10
			sizelst.Add(i)
		Next
		For i = 0 To 20
			strokewidthlst.Add(i)
		Next
		For i = 0 To 360 Step 10
			cornerradiuslst.Add(i)
		Next
		alignlst = Array As String("TOP_LEFT","TOP_CENTER","TOP_RIGHT", _
									  "CENTER_LEFT","CENTER","CENTER_RIGHT", _
									  "BOTTOM_LEFT","BOTTOM_CENTER","BOTTOM_RIGHT")
		set_progress
		Sleep(0)
		cbxwidth.SetItems(sizelst)
		cbxheight.SetItems(sizelst)
		cbxstrokewidth.SetItems(strokewidthlst)
		cbxcornerradius.SetItems(cornerradiuslst)
		cbxalignment.SetItems(alignlst)
		cbxalignment.SelectedIndex = 4
		cbxfontsize.SetItems(fontsizelst)
		cbxfontsize.SelectedIndex = 3
		fill_cbxtextcolors
		set_progress
		Sleep(0)
		ProgressBar1.Visible = False
	End If
End Sub
Private Sub update_properties_pane
	If sizelst.Size = 0 Then Return
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then
			If currnode.Width >= 10 Then cbxwidth.SelectedIndex = (currnode.Width/10) -1
			If currnode.Height >= 10 Then cbxheight.SelectedIndex = (currnode.Height/10) -1
			Dim shapemap As Map = collectionmap.Get(tag)
			If shapemap.ContainsKey("backgroundcolor") Then
				Dim backgroundcolor As String = collectionmap_get_property(tag,"backgroundcolor")
				For i = 0 To clvnamedcolors.Size - 1
					clvnamedcolors.GetPanel(i).Color = xui.Color_White
				Next
				clvnamedcolors.GetPanel(namedcolorindexmap.Get(backgroundcolor)-1).Color = xui.Color_ARGB(255,230,230,250)
				clvnamedcolors.JumpToItem(namedcolorindexmap.Get(backgroundcolor)-1)
			End If
		Else
			If currnode.Width >= 10 Then cbxwidth.SelectedIndex = (currnode.Width/10) -1
			If currnode.Height >= 10 Then cbxheight.SelectedIndex = (currnode.Height/10) -1
			If collectionmap.ContainsKey(tag) Then
				set_shape_properties(tag)
			End If
		End If
	End If
End Sub
Private Sub set_shape_properties(tag As String)
	Dim noborder As Boolean = collectionmap_get_property(tag,"noborder")
	If noborder = True Then
		cboxnoborder.Checked = True
	Else
		cboxnoborder.Checked = False
	End If
	Dim align As String = collectionmap_get_property(tag,"alignment")
	If alignlst.IndexOf(align) <> -1 Then
		cbxalignment.SelectedIndex = alignlst.IndexOf(align)
	End If
	Dim fontfamily As String = collectionmap_get_property(tag,"fontfamily")
	selectedfont = fontfamily
	For i = 0 To clvfonts.Size - 1
		clvfonts.GetPanel(i).Color = xui.Color_White
	Next
	clvfonts.GetPanel(fontindexmap.Get(selectedfont)).Color = xui.Color_ARGB(255,211,255,179)
	clvfonts.JumpToItem(fontindexmap.Get(selectedfont))
	Dim fontsize As Int = collectionmap_get_property(tag,"fontsize")
	If fontsizelst.IndexOf(fontsize) <> -1 Then
		cbxfontsize.SelectedIndex = fontsizelst.IndexOf(fontsize)
	End If
	Dim strokewidth As Int = collectionmap_get_property(tag,"strokewidth")
	If strokewidthlst.IndexOf(strokewidth) <> -1 Then
		cbxstrokewidth.SelectedIndex = strokewidthlst.IndexOf(strokewidth)
	End If
	Dim cornerradius As Int = collectionmap_get_property(tag,"cornerradius")
	If cornerradiuslst.IndexOf(cornerradius) <> -1 Then
		cbxcornerradius.SelectedIndex = cornerradiuslst.IndexOf(cornerradius)
	End If
	Dim text As String = collectionmap_get_property(tag,"text")
	If tatext.IsInitialized Then 
		tatext.Text = text
	End If
	Dim shapemap As Map = collectionmap.Get(tag)
	If shapemap.ContainsKey("backgroundcolor") Then
		Dim backgroundcolor As String = collectionmap_get_property(tag,"backgroundcolor")
		If backgroundcolor <> -1 Then
			For i = 0 To clvnamedcolors.Size - 1
				clvnamedcolors.GetPanel(i).Color = xui.Color_White
			Next
			clvnamedcolors.GetPanel(namedcolorindexmap.Get(backgroundcolor)-1).Color = xui.Color_ARGB(255,230,230,250)
			clvnamedcolors.JumpToItem(namedcolorindexmap.Get(backgroundcolor)-1)
		End If
	End If
	Dim textcolor As String = collectionmap_get_property(tag,"textcolor")
	If cbxtextcolors.IndexOf(textcolor) <> -1 Then
		cbxtextcolors.SelectedIndex = cbxtextcolors.IndexOf(textcolor)
	End If
End Sub
Public Sub fill_cbxtextcolors
	Dim lst As List
	lst.Initialize
	For i = 1 To jlst.Size -1
		Dim rec As List = jlst.Get(i)
		lst.Add(rec.Get(1))
		colorsmap.Put(rec.Get(1),rec.Get(3))
	Next
	cbxtextcolors.SetItems(lst)
End Sub
Private Sub cbxtextcolors_SelectedIndexChanged (Index As Int)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then Return
		Dim colorkey As String = cbxtextcolors.GetItem(Index)
		Dim RGB As List = clrfunctions.set_RGB_values(colorsmap.Get(colorkey))
		Dim tag As String = currnode.Tag
		Dim textcolor As Int = xui.Color_ARGB(255,RGB.Get(0),RGB.Get(1),RGB.Get(2))
		currnode.As(Label).TextColor = fx.Colors.From32Bit(textcolor)
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"textcolor",colorkey)
		End If
	End If
End Sub

Public Sub fill_clvnamedcolors
	clvnamedcolors.Clear
	For i = 1 To jlst.Size -1
		Dim rec As List = jlst.Get(i)
		Dim pn As Pane = set_clvnamedcolor_item(rec,i)
		clvnamedcolors.Add(pn,rec.Get(2))
		namedcolorindexmap.Put(pn.Tag,i)
	Next
End Sub
Private Sub set_clvnamedcolor_item(rec As List,index As Int) As Pane
	Dim pn As Pane
	pn.Initialize("")
	pn.LoadLayout("clvnamedcolorsitem_layout")
	pn.SetLayoutAnimated(0, 0, 0, 240, 45)
	Dim clrstr As String = rec.Get(3)			' red, green, blue
	RGB = clrfunctions.set_RGB_values(clrstr)
	lblcolor.TextColor = fx.Colors.From32Bit(clrfunctions.ContrastColor(xui.Color_ARGB(255,RGB.get(0),RGB.get(1),RGB.get(2))))
	lblcolor.Text = " " & index
	lblcolor.Style = "-fx-background-color:" & rec.Get(2)
	lblcolorname.Text = " " & rec.Get(1)
	pn.Tag = clrstr
	Return pn
End Sub
Private Sub clvnamedcolors_ItemClick (Index As Int, Value As Object)
	Dim rec As List = jlst.Get(Index+1)
	Dim clrstr As String = rec.Get(3)
	RGB = clrfunctions.set_RGB_values(clrstr)
	CSSUtils.SetBackgroundColor(currnode,fx.Colors.ARGB(200,RGB.get(0),RGB.get(1),RGB.get(2)))
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"backgroundcolor",clrstr)
			update_properties_pane
		End If
	End If
End Sub
Private Sub cbxwidth_SelectedIndexChanged (Index As Int)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		currnode.Width = cbxwidth.SelectedItem
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"width",cbxwidth.SelectedItem)
		End If
	End If
	lblmessage.Text = "  " & currnode.Tag & " left: " & currnode.Left & " top: " & currnode.Top & " width: " & currnode.Width & " height: " & currnode.Height
	lblselectedcomponent.Text = "  " & currnode.Tag & " L: " & currnode.Left & " T: " & currnode.Top & " W: " & currnode.Width & " H: " & currnode.Height
End Sub
Private Sub cbxheight_SelectedIndexChanged (Index As Int)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		currnode.Height = cbxheight.SelectedItem
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"height",cbxheight.SelectedItem)
		End If
	End If
	lblmessage.Text = "  " & currnode.Tag & " left: " & currnode.Left & " top: " & currnode.Top & " width: " & currnode.Width & " height: " & currnode.Height
	lblselectedcomponent.Text = "  " & currnode.Tag & " L: " & currnode.Left & " T: " & currnode.Top & " W: " & currnode.Width & " H: " & currnode.Height
End Sub
Private Sub cbxstrokewidth_SelectedIndexChanged (Index As Int)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then Return
		CSSUtils.SetBorder(currnode,cbxstrokewidth.SelectedItem,fx.Colors.Black,cbxcornerradius.SelectedItem)
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"strokewidth",cbxstrokewidth.SelectedItem)
		End If
	End If
End Sub
Private Sub cbxcornerradius_SelectedIndexChanged (Index As Int)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then Return
		CSSUtils.SetBorder(currnode,cbxstrokewidth.SelectedItem,fx.Colors.Black,cbxcornerradius.SelectedItem)
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"cornerradius",cbxcornerradius.SelectedItem)
		End If
	End If
End Sub
Private Sub cboxnoborder_CheckedChange(Checked As Boolean)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then Return
		If Checked Then
			CSSUtils.SetBorder(currnode,0,fx.Colors.Transparent,0)
			If collectionmap.ContainsKey(tag) Then
				collectionmap_change_property(tag,"noborder",True)
				collectionmap_change_property(tag,"strokewidth",0)
			End If
		Else
			CSSUtils.SetBorder(currnode,1,fx.Colors.Black,0)
			If collectionmap.ContainsKey(tag) Then
				collectionmap_change_property(tag,"noborder",False)
				collectionmap_change_property(tag,"strokewidth",1)
			End If
		End If
	End If
End Sub
Private Sub tatext_TextChanged (Old As String, New As String)
	If currnode.IsInitialized = False Then Return
	Dim tag As String = currnode.Tag
	If tag.Contains("card") Then Return
	If collectionmap.ContainsKey(tag) Then
		Dim shapemap As Map = collectionmap.Get(tag)
		shapemap.Put("text",New)
		currnode.Text = New
		collectionmap.Put(tag,shapemap)
	End If
'	CSSUtils.SetStyleProperty(currnode,"-fx-padding", "5 3 3 5")
End Sub
Private Sub fill_clvfonts
	For i = 0 To fontfamilylst.Size -1
		Dim pn As Pane = set_clvfonts_item(fontfamilylst.Get(i))
		clvfonts.Add(pn,pn.tag)
		fontindexmap.Put(pn.Tag,i)
	Next
	selectedfont = clvfonts.GetValue(2)
	clvfonts.GetPanel(2).Color = xui.Color_ARGB(255,230,230,250)
End Sub
Private Sub set_clvfonts_item(fntname As String) As Pane
	Dim pn As Pane = xui.CreatePanel("")
	pn.LoadLayout("clvfontsitem_layout")
	pn.SetLayoutAnimated(0,0,0,280,25)
	lblfontitem.Font = fx.CreateFont(fntname,14,False,False)
	lblfontitem.Text = fntname
	pn.Tag = fntname
	Return pn
End Sub
Private Sub clvfonts_ItemClick (Index As Int, Value As Object)
	For i = 0 To clvfonts.Size - 1
		clvfonts.GetPanel(i).Color = xui.Color_White
	Next
	clvfonts.GetPanel(Index).Color = xui.Color_ARGB(255,230,230,250)
	selectedfont = clvfonts.GetValue(Index)
	set_font(selectedfont)
End Sub
Private Sub tbtnitalic_SelectedChange(Selected As Boolean)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then Return
		currnode.As(Label).Font = fx.CreateFont(selectedfont,selectedfontsize,tbtnbold.Selected,tbtnitalic.Selected)
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"textitalic",tbtnitalic.Selected)
		End If			
	End If
End Sub
Private Sub tbtnbold_SelectedChange(Selected As Boolean)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then Return
		currnode.As(Label).Font = fx.CreateFont(selectedfont,selectedfontsize,tbtnbold.Selected,tbtnitalic.Selected)
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"textbold",tbtnbold.Selected)
		End If
	End If
End Sub
Private Sub cbxalignment_SelectedIndexChanged (Index As Int)
	set_alignment(Index)
End Sub
Private Sub cbxfontsize_SelectedIndexChanged (Index As Int)
	selectedfontsize = cbxfontsize.GetItem(Index)
	set_fontsize(selectedfontsize)
End Sub
Private Sub set_font(selfont As String)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then Return
		currnode.As(Label).Font = fx.CreateFont(selfont,selectedfontsize,False,False)
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"fontfamily",selfont)
		End If
	End If
End Sub
Private Sub set_alignment(index As Int)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then Return
		currnode.As(Label).Alignment = cbxalignment.GetItem(index)
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"alignment",cbxalignment.GetItem(index))
		End If
	End If
End Sub
Private Sub set_fontsize(selfontsize As Int)
	If currnode.IsInitialized Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then Return
		currnode.As(Label).Font = fx.CreateFont(selectedfont,selfontsize,False,False)
		If collectionmap.ContainsKey(tag) Then
			collectionmap_change_property(tag,"fontsize",selfontsize)
		End If
	End If	
End Sub
#End Region
#Region 04 cards
Private Sub add_card(shapetag As String)
	Dim pnl As Pane
	pnl.Initialize("pnl")
	Dim name As String = shapetag.SubString2(shapetag.LastIndexOf("\")+1,shapetag.LastIndexOf("."))
	Dim folder As String = shapetag.SubString2(0,shapetag.LastIndexOf("\"))
	Dim filename As String = shapetag.SubString(shapetag.LastIndexOf("\")+1)
	name = name & nodecnt
	Dim width As Int = 400
	Dim height As Int = 600
	If File.Exists(folder,filename) Then
		Dim bmp As B4XBitmap = xui.LoadBitmap(folder,filename)
		width = bmp.Width
		height = bmp.Height
		CSSUtils.SetBackgroundImage(pnl,folder,filename)
	End If
	Dim shapemap As Map
	shapemap.Initialize
	shapemap.Put("id",name)
	shapemap.Put("left",10)
	shapemap.Put("top",10)
	shapemap.Put("width",width)
	shapemap.Put("height",height)
	shapemap.Put("tag",shapetag)
	collectionmap.Put(name,shapemap)
	pnl.Left = shapemap.Get("left")
	pnl.top = shapemap.Get("top")
	pnl.PrefWidth = shapemap.Get("width")
	pnl.PrefHeight = shapemap.Get("height")
	pnl.Tag = shapemap.Get("id")
	panemain.AddNode(pnl,pnl.Left,pnl.top,pnl.PrefWidth,pnl.PrefHeight)
	currnode = pnl
	nodecnt = nodecnt + 1
End Sub
Private Sub pnl_MouseClicked(EventData As MouseEvent)
	Dim view As B4XView = Sender
	currnode = view
	lblmessage.Text = "  " & currnode.Tag & " left: " & currnode.Left & " top: " & currnode.Top & " width: " & currnode.Width & " height: " & currnode.Height
	lblselectedcomponent.Text = "  " & currnode.Tag & " L: " & currnode.Left & " T: " & currnode.Top & " W: " & currnode.Width & " H: " & currnode.Height
	update_properties_pane
	EventData.Consume
End Sub
Private Sub pnl_MouseDragged (EventData As MouseEvent)
	Dim nod As Node = Sender
	If pnlresizing = True Then
		resize_shape(nod, EventData.X,EventData.Y)
		EventData.Consume
		Return
	End If
	Dim event As JavaObject = EventData
	Dim offsetX, offsetY As Double
	offsetX = event.RunMethod("getSceneX",Null) - pressedX
	offsetY =  event.RunMethod("getSceneY",Null)- pressedY
	nod.Left = nod.Left + offsetX
	nod.Top = nod.Top + offsetY
	pressedX = event.RunMethod("getSceneX",Null)
	pressedY = event.RunMethod("getSceneY",Null)
	currnode = nod
	carddragged = True
	EventData.Consume
End Sub
Private Sub pnl_MousePressed (EventData As MouseEvent)
	Dim view As B4XView = Sender
	Dim event As JavaObject = EventData
	pressedX = event.RunMethod("getSceneX",Null)
	pressedY = event.RunMethod("getSceneY",Null)
	Dim rightsizing As Int = view.Width - 10
	Dim downsizing As Int = view.Height - 10
	Dim leftsizing As Int = 10
	Dim topsizing As Int = 10
	If EventData.X > rightsizing Or EventData.Y > downsizing Or EventData.X < leftsizing Or EventData.Y < topsizing Then
		pnlresizing = True
		oldx = EventData.X
		oldy = EventData.Y
	End If
	EventData.Consume
End Sub
Private Sub pnl_MouseReleased (EventData As MouseEvent)
	pnlresizing = False
	Dim view As B4XView = Sender
	If collectionmap.ContainsKey(view.Tag) = True Then
		Dim shapemap As Map = collectionmap.Get(view.Tag)
		shapemap.Put("left",view.Left)
		shapemap.Put("top",view.Top)
		shapemap.Put("width",view.Width)
		shapemap.Put("height",view.Height)
		collectionmap.Put(view.Tag,shapemap)
	End If
	snap_to_grid(view)
	If carddragged = False Then
		If EventData.PrimaryButtonPressed Then
			attach_children			'(view)
		End If
		If EventData.SecondaryButtonPressed Then
			detach_children			'(view)
		End If
	End If
	carddragged = False
	EventData.Consume
End Sub
Private Sub pnl_MouseEntered (EventData As MouseEvent)
	Dim view As B4XView = Sender
	CSSUtils.SetBorder(view,10,fx.Colors.Green,0)
End Sub
Private Sub pnl_MouseExited (EventData As MouseEvent)
	Dim view As B4XView = Sender
	CSSUtils.SetBorder(view,0,fx.Colors.Transparent,0)
End Sub
Private Sub pnl_MouseMoved (EventData As MouseEvent)
	Dim view As B4XView = Sender
	Dim rightsizing As Int = view.Width - 10
	Dim downsizing As Int = view.Height - 10
	Dim leftsizing As Int = 10
	Dim topsizing As Int = 10
	If EventData.X > rightsizing Or EventData.Y > downsizing Or EventData.X < leftsizing Or EventData.Y < topsizing Then
		view.As(Pane).MouseCursor = fx.Cursors.HAND
	Else
		view.As(Pane).MouseCursor = fx.Cursors.MOVE
	End If
End Sub
Public Sub attach_children			'(pnod As B4XView)
	If currnode.IsInitialized = False Then Return
	Dim pnod As B4XView = currnode
	Dim ptag As String = pnod.tag
	If ptag.Contains("card") = False Then Return
	Dim pshapemap As Map = collectionmap.Get(ptag)
	Dim pleft As Int = pshapemap.Get("left")
	Dim ptop As Int = pshapemap.Get("top")
	For Each nod As Node In panemain.GetAllViewsRecursive
		If nod.Tag <> "" Then
			If collectionmap.ContainsKey(nod.Tag) = True Then
				Dim name As String = nod.tag
				If name.Contains("card") = False Then
					Dim shapemap As Map = collectionmap.Get(name)
					Dim parent As String = shapemap.Get("parent")
					Dim left As Int = shapemap.Get("left")
					Dim top As Int = shapemap.Get("top")
					If parent = "" Then
						If left >= pleft And top >= ptop Then
							If left+nod.PrefWidth <= pleft+pnod.Width And top+nod.PrefHeight <= ptop+pnod.Height Then
								nod.RemoveNodeFromParent
								pnod.AddView(nod,nod.Left,nod.Top,nod.PrefWidth,nod.PrefHeight)
								shapemap.Put("parent",pnod.Tag)
								shapemap.Put("left",nod.Left-pnod.Left)
								shapemap.Put("top",nod.Top-pnod.Top)
								collectionmap.Put(name,shapemap)
							End If
						End If
					End If
				End If
			End If
		End If
	Next
'	Log(collectionmap.As(JSON).ToString)
End Sub
Public Sub detach_children				'(pnod As B4XView)
	If currnode.IsInitialized = False Then Return
	Dim pnod As B4XView = currnode
	For Each nod As Node In pnod.GetAllViewsRecursive
		If nod.Tag <> "" Then
			If collectionmap.ContainsKey(nod.Tag) = True Then
				nod.RemoveNodeFromParent
				Dim shapemap As Map = collectionmap.Get(nod.Tag)
				shapemap.Put("parent","")
				shapemap.Put("left",20)
				shapemap.Put("top",20)
				collectionmap.Put(nod.tag,shapemap)
				panemain.AddNode(nod,nod.Left,nod.Top,nod.PrefWidth,nod.PrefHeight)
			End If
		End If
	Next
'	Log(collectionmap.As(JSON).ToString)
End Sub
Public Sub save_card
	If currnode.IsInitialized = False Then Return
	Dim tag As String = currnode.Tag
	If tag.Contains("card") = False Then
		xui.MsgboxAsync("Click on the header or footer of a card first to select.","Save card")
		Return
	End If
	fchoose.InitialDirectory = cardsfolder
	fchoose.InitialFileName = tag & ".json"
	fchoose.setExtensionFilter("Cards", Array As String("*.json"))
	Dim fname As String = fchoose.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
	If fname = "" Then Return
	Dim path As String = fname.SubString2(0,fname.LastIndexOf("\")+1)
	Dim filename As String = fname.SubString(fname.LastIndexOf("\")+1)
	Dim cmap As Map
	cmap.Initialize
	For Each name As String In collectionmap.Keys
		Dim shapemap As Map = collectionmap.Get(name)
		If name = tag Then
			cmap.Put(name,shapemap)
		Else
			If name.Contains("card") = False Then
				If shapemap.Get("parent") = tag Then
					cmap.Put(name,shapemap)	
				End If
			End If
		End If
	Next
	File.WriteString(path,filename,cmap.As(JSON).ToString)
End Sub
public Sub load_card
	If tatext.IsInitialized Then tatext.Text = ""
	fchoose.InitialDirectory = cardsfolder
	fchoose.setExtensionFilter("Cards", Array As String("*.json"))
	Dim fname As String = fchoose.ShowOpen(B4XPages.GetNativeParent(B4XPages.MainPage))
	If fname = "" Then Return
	Dim path As String = fname.SubString2(0,fname.LastIndexOf("\")+1)
	Dim filename As String = fname.SubString(fname.LastIndexOf("\")+1)
	Dim jsonstr As String
	jsonstr = File.ReadString(path,filename)
	Dim cmap As Map = jsonstr.As(JSON).ToMap
	For Each name As String In cmap.Keys			' process card first (parentnode)
		If name.Contains("card") Then
			Dim shapemap As Map = cmap.Get(name)
			set_card(shapemap)
		End If
	Next
	For Each name As String In cmap.Keys			' process children
		Dim shapemap As Map = cmap.Get(name)
		If name.Contains("card") = False Then
			set_shape(shapemap)
		End If
	Next
	currnode = parentnode
	attach_children
'	Log(collectionmap.As(JSON).ToString)
End Sub
Private Sub set_card(smap As Map)
	Dim pnl As Pane
	pnl.Initialize("pnl")
	Dim tag As String = smap.Get("tag")
	Dim name As String = tag.SubString2(tag.LastIndexOf("\")+1,tag.LastIndexOf("."))
	Dim folder As String = tag.SubString2(0,tag.LastIndexOf("\"))
	Dim filename As String = tag.SubString(tag.LastIndexOf("\")+1)
	If File.Exists(folder,filename) Then
		CSSUtils.SetBackgroundImage(pnl,folder,filename)
	End If
	name = name & nodecnt
	pnl.Left = smap.Get("left")
	pnl.top = smap.Get("top")
	pnl.PrefWidth = smap.Get("width")
	pnl.PrefHeight = smap.Get("height")
	smap.Put("id",name)
	pnl.Tag = smap.Get("id")
	If smap.ContainsKey("backgroundcolor") Then
		Dim backgroundcolor As String = smap.Get("backgroundcolor")
		RGB = clrfunctions.set_RGB_values(backgroundcolor)
		CSSUtils.SetBackgroundColor(pnl,fx.Colors.ARGB(255,RGB.Get(0),RGB.Get(1),RGB.Get(2)))
	End If
	collectionmap.Put(name,smap)
	panemain.AddNode(pnl,pnl.Left,pnl.top,pnl.PrefWidth,pnl.PrefHeight)
	currnode = pnl
	parentnode = currnode
	nodecnt = nodecnt + 1
End Sub
Private Sub set_shape(smap As Map)
	Dim lbl As Label
	lbl.Initialize("lbl")
	Dim tag As String = smap.Get("tag")
	Dim name As String = tag.SubString2(tag.LastIndexOf("\")+1,tag.LastIndexOf("."))
	Dim folder As String = tag.SubString2(0,tag.LastIndexOf("\"))
	Dim filename As String = tag.SubString(tag.LastIndexOf("\")+1)
	If File.Exists(folder,filename) Then
		CSSUtils.SetBackgroundImage(lbl,folder,filename)
	End If
	name = name & nodecnt
	lbl.Left = smap.Get("left")
	lbl.top = smap.Get("top")
	lbl.PrefWidth = smap.Get("width")
	lbl.PrefHeight = smap.Get("height")
	lbl.Text = smap.Get("text")
	lbl.WrapText = smap.Get("wraptext")
	smap.Put("id",name)
	lbl.Tag = smap.Get("id")
	Dim cornerradius As Int = smap.Get("cornerradius")
	Dim strokewidth As Int = smap.Get("strokewidth")
	Dim noborder As Boolean = smap.Get("noborder")
	Dim textbold As Boolean = smap.Get("textbold")
	Dim textitalic As Boolean = smap.Get("textitalic")
	Dim fontfamily As String = smap.Get("fontfamily")
	Dim fontsize As Int = smap.Get("fontsize")
	Dim textcolor As String = smap.Get("textcolor")
	Dim backgroundcolor As String = smap.Get("backgroundcolor")
	Dim alignment As String = smap.Get("alignment")
	If noborder Then
		CSSUtils.SetBorder(lbl,0,fx.Colors.Transparent,0)
	Else
		CSSUtils.SetBorder(lbl,strokewidth,fx.Colors.Black,cornerradius)
	End If
	CSSUtils.SetBorder(lbl,strokewidth,fx.Colors.Black,cornerradius)
	lbl.Font = fx.CreateFont(fontfamily,fontsize,textbold,textitalic)
	lbl.Alignment = alignment
	RGB = clrfunctions.set_RGB_values(colorsmap.Get(textcolor))
	lbl.TextColor = fx.Colors.ARGB(255,RGB.Get(0),RGB.Get(1),RGB.Get(2))
	If backgroundcolor <> -1 Then
		RGB = clrfunctions.set_RGB_values(backgroundcolor)		
		CSSUtils.SetBackgroundColor(lbl,fx.Colors.ARGB(255,RGB.Get(0),RGB.Get(1),RGB.Get(2)))
	End If
	smap.Put("parent","")		' auto re-attach after load card
	collectionmap.Put(name,smap)
	panemain.AddNode(lbl,lbl.Left,lbl.top,lbl.PrefWidth,lbl.PrefHeight)
	currnode = lbl
	selectedfont = smap.Get("fontfamily")
	selectedfontsize = smap.Get("fontsize")
	nodecnt = nodecnt + 1
End Sub
#End Region
#Region 05 shapes
Private Sub add_shape(shapetag As String)
	Dim lbl As Label
	lbl.Initialize("lbl")
	Dim name As String = shapetag.SubString2(shapetag.LastIndexOf("\")+1,shapetag.LastIndexOf("."))
	Dim folder As String = shapetag.SubString2(0,shapetag.LastIndexOf("\"))
	Dim filename As String = shapetag.SubString(shapetag.LastIndexOf("\")+1)
	name = name & nodecnt
	Dim width As Int = 100
	Dim height As Int = 100
	If File.Exists(folder,filename) Then
		Dim bmp As B4XBitmap = xui.LoadBitmap(folder,filename)
		width = bmp.Width
		height = bmp.Height
		CSSUtils.SetBackgroundImage(lbl,folder,filename)
	End If
	Dim shapemap As Map
	shapemap.Initialize
	shapemap.Put("id",name)
	shapemap.Put("left",20)
	shapemap.Put("top",20)
	shapemap.Put("width",width)
	shapemap.Put("height",height)
	shapemap.Put("tag",shapetag)
	shapemap.Put("parent","")	
	shapemap.Put("noborder",False)
	shapemap.Put("text","")
	shapemap.Put("textcolor","black")
	shapemap.Put("textbold",False)
	shapemap.Put("textitalic",False)
	shapemap.Put("wraptext",True)
	shapemap.Put("fontfamily","Arial")
	shapemap.Put("fontsize",16)
	shapemap.Put("alignment","CENTER")
	shapemap.Put("strokewidth",1)
	shapemap.Put("cornerradius",0)
	shapemap.Put("backgroundcolor",xui.Color_White)
'	shapemap.Put("padding","5 3 3 5")
	collectionmap.Put(name,shapemap)
	lbl.Left = shapemap.Get("left")
	lbl.top = shapemap.Get("top")
	lbl.PrefWidth = shapemap.Get("width")
	lbl.PrefHeight = shapemap.Get("height")
	lbl.Tag = shapemap.Get("id")
	lbl.Text = ""
	lbl.WrapText = True
	CSSUtils.SetBorder(lbl,1,fx.Colors.Black,0)
	lbl.TextColor = fx.Colors.From32Bit(xui.Color_Black)
	lbl.Font = fx.CreateFont("Arial",16,False,False)
	lbl.Alignment = "CENTER"
	CSSUtils.SetBackgroundColor(lbl,fx.Colors.From32Bit(xui.Color_Transparent))
	panemain.AddNode(lbl,lbl.Left,lbl.top,lbl.PrefWidth,lbl.PrefHeight)
	currnode = lbl
	selectedfont = shapemap.Get("fontfamily")
	selectedfontsize = shapemap.Get("fontsize")
	nodecnt = nodecnt + 1
End Sub
Private Sub lbl_MouseClicked(EventData As MouseEvent)
	Dim view As B4XView = Sender
	currnode = view
	If EventData.SecondaryButtonPressed Then
		remove_shape
		EventData.Consume
		Return
	End If
	lblmessage.Text = "  " & currnode.tag & " left: " & currnode.Left & " top: " & currnode.Top & " width: " & currnode.Width & " height: " & currnode.Height
	lblselectedcomponent.Text = "  " & currnode.tag & " L: " & currnode.Left & " T: " & currnode.Top & " W: " & currnode.Width & " H: " & currnode.Height
	update_properties_pane
	EventData.Consume
'	Log(collectionmap.As(JSON).ToString)
End Sub
Private Sub lbl_MouseDragged (EventData As MouseEvent)
	Dim nod As Node = Sender
	If lblresizing = True Then
		resize_shape(nod, EventData.X,EventData.Y)
		EventData.Consume
		Return
	End If
	Dim event As JavaObject = EventData
	Dim offsetX, offsetY As Double
	offsetX = event.RunMethod("getSceneX",Null) - pressedX
	offsetY =  event.RunMethod("getSceneY",Null)- pressedY
	nod.Left = nod.Left + offsetX
	nod.Top = nod.Top + offsetY
	pressedX = event.RunMethod("getSceneX",Null)
	pressedY = event.RunMethod("getSceneY",Null)
	currnode = nod
	EventData.Consume
End Sub
Private Sub lbl_MousePressed (EventData As MouseEvent)
	Dim view As B4XView = Sender
	Dim event As JavaObject = EventData
	pressedX = event.RunMethod("getSceneX",Null)
	pressedY = event.RunMethod("getSceneY",Null)
	Dim rightsizing As Int = view.Width - 10
	Dim downsizing As Int = view.Height - 10
	Dim leftsizing As Int = 10
	Dim topsizing As Int = 10
	If EventData.X > rightsizing Or EventData.Y > downsizing Or EventData.X < leftsizing Or EventData.Y < topsizing Then
		lblresizing = True
		oldx = EventData.X
		oldy = EventData.Y
	End If
	EventData.Consume
End Sub
Private Sub lbl_MouseReleased (EventData As MouseEvent)
	lblresizing = False
	Dim view As B4XView = Sender
	If collectionmap.ContainsKey(view.Tag) = True Then
		Dim shapemap As Map = collectionmap.Get(view.Tag)
		shapemap.Put("left",view.Left)
		shapemap.Put("top",view.Top)
		shapemap.Put("width",view.Width)
		shapemap.Put("height",view.Height)
		collectionmap.Put(view.Tag,shapemap)
	End If
	snap_to_grid(view)
	EventData.Consume
End Sub
Private Sub lbl_MouseEntered (EventData As MouseEvent)
	Dim view As B4XView = Sender
	currnode = view
	CSSUtils.SetBorder(view,10,fx.Colors.Blue,0)	
End Sub
Private Sub lbl_MouseExited (EventData As MouseEvent)
	Dim view As B4XView = Sender
	Dim tag As String = view.Tag
	Dim shapemap As Map = collectionmap.Get(tag)
	If shapemap.Get("noborder") = False Then
		CSSUtils.SetBorder(view,1,fx.Colors.Black,0)
	Else
		CSSUtils.SetBorder(view,0,fx.Colors.Transparent,0)
	End If
End Sub
Private Sub lbl_MouseMoved (EventData As MouseEvent)
	Dim view As B4XView = Sender
	Dim rightsizing As Int = view.Width - 10
	Dim downsizing As Int = view.Height - 10
	Dim leftsizing As Int = 10
	Dim topsizing As Int = 10
	If EventData.X > rightsizing Or EventData.Y > downsizing Or EventData.X < leftsizing Or EventData.Y < topsizing Then
		view.As(Label).MouseCursor = fx.Cursors.HAND
	Else
		view.As(Label).MouseCursor = fx.Cursors.MOVE
	End If
	EventData.Consume
End Sub
Private Sub resize_shape(nod As Node, parentX As Double, parentY As Double)
	Dim tag As String = nod.Tag
	If tag.Contains("card") = True And pnlresizing = False Then Return
	If tag.Contains("card") = False And lblresizing = False Then Return
	Dim shapemap As Map = collectionmap.Get(nod.tag)
	Dim width As Int = shapemap.Get("width")
	Dim height As Int = shapemap.Get("height")
	Dim offsetx As Int = parentX - oldx
	Dim offsety As Int = parentY - oldy
	If offsetx > 0 Then
		If width >= 50 Then
			nod.prefWidth = width + 1
		Else
			nod.prefWidth = 50
		End If
		shapemap.Put("width",nod.prefWidth)
		collectionmap.Put(nod.tag,shapemap)
	End If
	If offsetx < 0 Then
		If width >= 50 Then
			nod.prefWidth = width -1
		Else
			nod.prefWidth = 50
		End If
		shapemap.Put("width",nod.prefWidth)
		collectionmap.Put(nod.tag,shapemap)
	End If
	If offsety > 0 Then
		If height >= 50 Then
			nod.PrefHeight = height + 1
		Else
			nod.PrefHeight = 50
		End If
		shapemap.Put("height",nod.PrefHeight)
		collectionmap.Put(nod.tag,shapemap)
	End If
	If offsety < 0 Then
		If height >= 50 Then
			nod.PrefHeight = height -1
		Else
			nod.PrefHeight = 50
		End If
		shapemap.Put("height",nod.PrefHeight)
		collectionmap.Put(nod.tag,shapemap)
	End If
End Sub
Public Sub rotate_shape_right				' CTRL + arrowkey right
	If currnode.IsInitialized = True Then
		Dim vw As B4XView = currnode
		vw.Rotation = vw.Rotation + 5
		If vw.Rotation < -360 Then vw.Rotation = -360
		If vw.Rotation > 360 Then vw.Rotation = 360
	End If
End Sub
Public Sub rotate_shape_left				' CTRL + arrowkey left
	If currnode.IsInitialized = True Then
		Dim vw As B4XView = currnode
		vw.Rotation = vw.Rotation - 5
		If vw.Rotation < -360 Then vw.Rotation = -360
		If vw.Rotation > 360 Then vw.Rotation = 360
	End If
End Sub
Public Sub flip_shape_up					' CTRL + arrowkey up
	If currnode.IsInitialized = True Then
		Dim vw As B4XView = currnode
		vw.Rotation = vw.Rotation - 180
		If vw.Rotation < -360 Then vw.Rotation = -360
		If vw.Rotation > 360 Then vw.Rotation = 360
	End If
End Sub
Public Sub flip_shape_down					' CTRL + arrowkey down
	If currnode.IsInitialized = True Then
		Dim vw As B4XView = currnode
		vw.Rotation = vw.Rotation + 180
		If vw.Rotation < -360 Then vw.Rotation = -360
		If vw.Rotation > 360 Then vw.Rotation = 360
	End If
End Sub
Public Sub remove_shape
	Dim answer As Object = xui.Msgbox2Async("Are you sure?", "Remove card or shape", "Yes", "Cancel", "No", Null)
	Wait For (answer) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		If currnode.IsInitialized = True Then
			currnode.RemoveViewFromParent
			If collectionmap.ContainsKey(currnode.Tag) = True Then
				collectionmap.Remove(currnode.Tag)
			End If
		End If
	End If
End Sub
Public Sub copy_shape
'	xui.MsgboxAsync("duplicate shape","Duplicate")
	If currnode.IsInitialized = True Then
		Dim tag As String = currnode.Tag
		If tag.Contains("card") Then Return
		Dim originalmap As Map = collectionmap.Get(tag)
		Dim tag As String = originalmap.Get("tag")
		Dim name As String = tag.SubString2(tag.LastIndexOf("\")+1,tag.LastIndexOf("."))
		Dim folder As String = tag.SubString2(0,tag.LastIndexOf("\"))
		Dim filename As String = tag.SubString(tag.LastIndexOf("\")+1)
		name = name & nodecnt
		Dim shapemap As Map
		shapemap.Initialize
		shapemap.Put("id",name)
		shapemap.Put("left",originalmap.Get("left")+10)
		shapemap.Put("top",originalmap.Get("top")+10)
		shapemap.Put("width",originalmap.Get("width"))
		shapemap.Put("height",originalmap.Get("height"))
		shapemap.Put("tag",originalmap.Get("tag"))
		shapemap.Put("parent","")
		shapemap.Put("noborder",originalmap.Get("noborder"))
		shapemap.Put("text",originalmap.Get("text"))
		shapemap.Put("textcolor",originalmap.Get("textcolor"))
		shapemap.Put("textbold",originalmap.Get("textbold"))
		shapemap.Put("textitalic",originalmap.Get("textitalic"))
		shapemap.Put("wraptext",originalmap.Get("wraptext"))
		shapemap.Put("fontfamily",originalmap.Get("fontfamily"))
		shapemap.Put("fontsize",originalmap.Get("fontsize"))
		shapemap.Put("alignment",originalmap.Get("alignment"))
		shapemap.Put("strokewidth",originalmap.Get("strokewidth"))
		shapemap.Put("cornerradius",originalmap.Get("cornerradius"))
		shapemap.Put("backgroundcolor",originalmap.Get("backgroundcolor"))
		collectionmap.Put(name,shapemap)
		Dim lbl As Label
		lbl.Initialize("lbl")
		lbl.Left = shapemap.Get("left")
		lbl.top = shapemap.Get("top")
		lbl.PrefWidth = shapemap.Get("width")
		lbl.PrefHeight = shapemap.Get("height")
		lbl.Text = shapemap.Get("text")
		lbl.WrapText = shapemap.Get("wraptext")
		lbl.Tag = shapemap.Get("id")
		Dim cornerradius As Int = shapemap.Get("cornerradius")
		Dim strokewidth As Int = shapemap.Get("strokewidth")
		Dim noborder As Boolean = shapemap.Get("noborder")
		Dim textbold As Boolean = shapemap.Get("textbold")
		Dim textitalic As Boolean = shapemap.Get("textitalic")
		Dim fontfamily As String = shapemap.Get("fontfamily")
		Dim fontsize As Int = shapemap.Get("fontsize")
		Dim textcolor As String = shapemap.Get("textcolor")
		Dim backgroundcolor As String = shapemap.Get("backgroundcolor")
		Dim alignment As String = shapemap.Get("alignment")
		If noborder Then
			CSSUtils.SetBorder(lbl,0,fx.Colors.Transparent,0)
		Else
			CSSUtils.SetBorder(lbl,strokewidth,fx.Colors.Black,cornerradius)
		End If
		CSSUtils.SetBorder(lbl,strokewidth,fx.Colors.Black,cornerradius)
		lbl.Font = fx.CreateFont(fontfamily,fontsize,textbold,textitalic)
		lbl.Alignment = alignment
		RGB = clrfunctions.set_RGB_values(colorsmap.Get(textcolor))
		lbl.TextColor = fx.Colors.ARGB(255,RGB.Get(0),RGB.Get(1),RGB.Get(2))
		If backgroundcolor <> -1 Then
			RGB = clrfunctions.set_RGB_values(backgroundcolor)
			CSSUtils.SetBackgroundColor(lbl,fx.Colors.ARGB(255,RGB.Get(0),RGB.Get(1),RGB.Get(2)))
		End If
		If File.Exists(folder,filename) Then
			CSSUtils.SetBackgroundImage(lbl,folder,filename)
		End If
		panemain.AddNode(lbl,lbl.Left,lbl.top,lbl.PrefWidth,lbl.PrefHeight)
		currnode = lbl
		selectedfont = shapemap.Get("fontfamily")
		selectedfontsize = shapemap.Get("fontsize")
		nodecnt = nodecnt + 1
	End If
End Sub
#End Region
#Region 06 collectionmap
Private Sub collectionmap_change_property(name As String, prop As String, value As Object)
	Dim shapemap As Map = collectionmap.Get(name)
	shapemap.Put(prop,value)
	collectionmap.Put(name,shapemap)
End Sub
Private Sub collectionmap_get_property(name As String, prop As String) As Object
	Dim shapemap As Map = collectionmap.Get(name)
	Return shapemap.Get(prop)
End Sub
#End Region
#Region 07 keyboard events
Private Sub fill_clvkeys
	keylst = Array As String("DEL = remove card or shape", _
		"CTRL+A = attach children","CTRL+C = copy shape","CTRL+D = detach children", _
		"CTRL+L = load card","CTRL+R = reset main panel","CTRL+S = save card", _
		"CTRL+UP-arrow = flip shape up","CTRL+DOWN-arrow = flip shape down", _
		"CTRL+LEFT-arrow = rotate shape left","CTRL+RIGHT-arrow = rotate shape right")
		For i = 0 To keylst.Size -1
			Dim keystroke As String = keylst.Get(i)
			clvkeys.AddTextItem(" " & keystroke,i)
			clvkeys.GetPanel(i).GetView(0).Color = xui.Color_LightGray
		Next
End Sub
Private Sub clvkeys_ItemClick (Index As Int, Value As Object)
	Select Value
		Case 0					' DEL
			remove_shape
		Case 1					' CTRL + A
			attach_children
		Case 2					' CTRL + C
			copy_shape
		Case 3					' CTRL + D
			detach_children
		Case 4					' CTRL + L
			load_card
		Case 5					' CTRL + R
			reset_panemain
		Case 6					' CTRL + S
			save_card
		Case 7					' CTRL + UP-arrow
			flip_shape_up
		Case 8					' CTRL + DOWN-arrow
			flip_shape_down
		Case 9					' CTRL + LEFT-arrow
			rotate_shape_left
		Case 10					' CTRL + RIGHT-arrow
			rotate_shape_right
	End Select
End Sub
#End Region
